﻿<%@ WebHandler Language="C#" Class="Loader" %>

using System;
using System.Web;
using System.Web.UI;

public class Loader : IHttpHandler
{
  public void ProcessRequest(HttpContext context)
  {
    // получение значения параметра Page 
    string pageName = context.Request.QueryString["Page"];

    // стоп при отстутствии параметра Page
    if (pageName == null || pageName == "") return;

    // подмена URL в зависимости от запрошенной страницы
    if (pageName.ToLower() == "ajax-php-book-review.html")
    {
      // допустим, что ID статьи AJAX-PHP-Book-Review.html равен 35
      context.RewritePath("/Product.aspx?ProductID=35");

      // создание компилированного экземпляра страницы, которую нужно загрузить
      IHttpHandler handler = PageParser.GetCompiledPageInstance
                             ("Product.aspx", null, context);

      // загрузка новой страницы
      handler.ProcessRequest(context);
    }
    else
    {
      // если название статьи не распознано - возврат кода состояния 404
      context.Response.Status = "404 Not Found";
    }
  }
 
  public bool IsReusable {
    get {
      return false;
    }
  }
}