﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.Configuration;

public partial class UserControls_SimpleCaptcha : System.Web.UI.UserControl
{
  // определение массива с известными числами
  private static string[] numbers = 
  { "ноль", "один", "два", "три", "четыре", "пять", "шесть", 
    "семь", "восемь", "девять", "десять", "одиннадцать", "двенадцать",
    "тринадцать", "четырнадцать", "пятнадцать", "шестнадцать",
    "семнадцать", "восемнадцать", "девятнадцать", "двадцать" };

  // определение различных видов вопросов
  private static string[] questions = 
  { "Сколько будет {0} плюс {1}?",
    "Чему равна сумма {0} и {1}?", 
    "Сколько будет {0} прибавить {1}?",
    "Чему равно {0} + {1}?" };

  // вывод вопроса captcha при загрузке страницы
  protected void Page_Load(object sender, EventArgs e)
  {
    // Не перевыводить вопрос при отправках данных
    if (!IsPostBack)
    {
      displayQuestion();
    }
  }

  // если ответ верен, возврат true, а иначе false 
  public bool CheckAnswer()
  {
    // выборка ответа и хеша правильного ответа
    string answer = captchaAnswerTextBox.Text;
    string correctAnswerHash = correctAnswerHidden.Value;

    // вычисление хеша ответа
    answer = answer.Trim() + HttpContext.Current.Request.UserHostAddress;
    string answerHash =
      FormsAuthentication.HashPasswordForStoringInConfigFile(answer, "md5");

    // вывод нового вопроса
    displayQuestion();

    // указание, был ли верен ответ
    return (answerHash == correctAnswerHash);
  }

  private void displayQuestion()
  {
    // генерация случайных чисел и вопроса
    Random random = new Random();
    int number_1 = random.Next(numbers.Length);
    int number_2 = random.Next(numbers.Length);
    int question_no = random.Next(questions.Length);

    // формирование вопроса
    string question = String.Format(questions[question_no],
                                    numbers[number_1], numbers[number_2]);

    // вычисление ответа, добавление IP посетителя и вычисление хеша
    string answer = (number_1 + number_2).ToString();
    answer += HttpContext.Current.Request.UserHostAddress;
    string answerHash =
      FormsAuthentication.HashPasswordForStoringInConfigFile(answer, "md5");

    // сохранение хеша правильного ответа и заполнение формы
    correctAnswerHidden.Value = answerHash;
    captchaLabel.Text = question;
    captchaAnswerTextBox.Text = "";
  }
}