﻿<%@ WebHandler Language="C#" Class="FortuneCookie" %>

using System;
using System.Web;
using System.Drawing;
using System.Drawing.Imaging;

// создание случайного изображения с предсказательным пряником
public class FortuneCookie : IHttpHandler
{
  public void ProcessRequest(HttpContext context)
  {
    // Определение возможных предсказаний судьбы
    string[] fortunes = {
      "Вашим любимым автором станет\r\nДжейми Сирович.",
      "Вы порекомендуете эту книгу\r\nвсем своим друзьям.",
      "Завтра вы получите\r\nсвой первый миллион.",
      "Вы прочитаете книгу\r\nОсновы библиотеки Microsoft AJAX" };

    // Получение случайного предсказания
    Random randomGenerator = new Random();
    string fortuneMessage = fortunes[randomGenerator.Next(fortunes.Length)];

    // Загрузка пустого изображения предсказательного пряника
    string imageLocation = context.Server.MapPath("/Images/fortune_cookie.gif");
    Bitmap emptyCookieBitmap = new Bitmap(imageLocation);

    // Создание нового изображения предсказательного пряника
    Bitmap fortuneCookieBitmap =
      new Bitmap(emptyCookieBitmap.Width, emptyCookieBitmap.Height);

    // Создание объекта Graphics и отрисовка пряника с его помощью
    Graphics gr = Graphics.FromImage(fortuneCookieBitmap);
    gr.DrawImage(emptyCookieBitmap, 0, 0);

    // Вывод текста предсказания на изображении пряника
    Font messageFont = new Font("Comic Sans MS", 10, FontStyle.Bold);
    gr.DrawString(fortuneMessage, messageFont, Brushes.Black, 130, 48);

    // Вывод изображения и очистка объекта Graphics 
    context.Response.Clear();
    context.Response.ContentType = "image/jpeg";
    fortuneCookieBitmap.Save(context.Response.OutputStream, ImageFormat.Jpeg);
    gr.Dispose();
  }

  public bool IsReusable
  {
    get
    {
      return true;
    }
  }
}