﻿using System;
using System.Web;

/// <summary>
/// Краткое описание GeoTarget
/// </summary>

public class GeoTarget
{
  // возвращает код региона текущего посетителя
  public static string GetRegionCode()
  {
    string visitorIp = HttpContext.Current.Request["REMOTE_ADDR"];
    return GetRegionCode(visitorIp);
  }

  // возвращает код региона по заданному IP
  public static string GetRegionCode(string ip)
  {
    string[] ipp = ip.Split(new char[] { '.' });

    long longIp = 16777216 * long.Parse(ipp[0]) + 65536 * long.Parse(ipp[1]) +
                  256 * long.Parse(ipp[2]) + long.Parse(ipp[3]);

    return GeoTargetDb.GetRegion(longIp);
  }

  // проверка, находится ли текущий посетитель в указанном регионе
  public static bool IsRegionCode(string regionCode)
  {
    return (GetRegionCode() == regionCode);
  }

  // проверка, находится ли указанный IP в указанном регионе
  public static bool IsRegionCode(string regionCode, string ip)
  {
    return (GetRegionCode(ip) == regionCode);
  }
}