﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Globalization" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
  protected void Page_Load(object sender, EventArgs e)
  {
    string myString = "México & Mexico";
    // Кодирование HTML
    originalLabel.Text = HttpUtility.HtmlEncode(myString);

    // Еще одно кодирование HTML для вывода HTML-кода в web-браузере
    htmlEncodedLabel.Text = HttpUtility.HtmlEncode(originalLabel.Text);

    // Кодирование URL
    urlEncodedLabel.Text = HttpUtility.UrlEncode(myString);

    // Удаление надстрочных знаков
    noDiacriticsLabel.Text = removeDiacritics(myString);
  }

  // функция удаления надстрочных знаков по мотивам статьи Майкла Каплана по адресу
  // http://blogs.msdn.com/michkap/archive/2005/02/19/376617.aspx
  private string removeDiacritics(string s)
  {
    string normalizedString = s.Normalize(NormalizationForm.FormD);
    StringBuilder stringBuilder = new StringBuilder();

    foreach (char c in normalizedString)
      if (CharUnicodeInfo.GetUnicodeCategory(c) != UnicodeCategory.NonSpacingMark)
        stringBuilder.Append(c);

    return stringBuilder.ToString();
  }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
  <title>Проверка кодирования ASP.NET</title>
</head>
<body>
  <form id="form1" runat="server">
    <p>
      Исходная строка: <asp:Label ID="originalLabel" runat="server" />
    </p>
    <p>
      Кодированный URL: <asp:Label ID="urlEncodedLabel" runat="server" />
    </p>
    <p>
      Кодированный HTML: <asp:Label ID="htmlEncodedLabel" runat="server" />
    </p>
    <p>
      Без надстрочных знаков: <asp:Label ID="noDiacriticsLabel" runat="server" />
    </p>
  </form>
</body>
</html>