﻿<%@ Page Language="C#" %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.IO" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
  protected void Page_Load(object sender, EventArgs e)
  {
    // первоначальный URL 
    string url = "http://www.cristiandarie.ro/seophp.aspx";

    // объект запроса
    HttpWebRequest request;

    // сначала считаем, что иходный URL является окончательным URL
    bool reachedDestination = true;

    // выполнять не более чем указанное количество запросов
    int maxRequests = 10;

    // при каждой итерации выводится информация об одном запросе
    do
    {
      // первоначальная очистка местоположения назначения
      string location = null;

      // попытка чтения данных из URL
      try
      {      
        // HTTP-запрос без разрешения автоматических перенаправлений
        request = (HttpWebRequest)HttpWebRequest.Create(url);
        request.AllowAutoRedirect = false;

        // вывод URL, который мы пытаемся прочитать
        myOutput.Text += "URL: " + url;

        // выборка содержимого
        HttpWebResponse linkResponse = (HttpWebResponse)request.GetResponse();

        // выборка местоположения
        location = linkResponse.Headers["Location"];

        // вывод информации об URL
        string output = "";
        output += "<p>Сервер: " + linkResponse.Server;
        output += "<br />Тип контента: " + linkResponse.ContentType;
        output += "<br />Длина контента: " + linkResponse.ContentLength;
        output += "<br />Код состояния: " + (int)linkResponse.StatusCode;
        output += "<br />Описание состояния: " + linkResponse.StatusDescription;
        if (location != null)
          output += "<br />Назначение: " + location + "</p>";
        myOutput.Text += output;
      }
      catch (Exception ex)
      {
        myOutput.Text += "<br />Ошибка: " + ex.Message;
      }

      // определение, нужна ли еще одна итерация
      if (location != null)
      {
        url = location;
        reachedDestination = false;
      }
      else
        reachedDestination = true;

      // отсчет до максимально допустимого количества запросов
      maxRequests--;
    }

    // цикл до достижения назначения или
    // максимально допустимого количества запросов
    while (!reachedDestination && maxRequests > 0) ;
  }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
  <title>Проверка тестера ссылок</title>
</head>
<body>
  <form id="form1" runat="server">
    <div>
      <asp:Literal runat="server" ID="myOutput" />
    </div>
  </form>
</body>
</html>