﻿using System;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

/// <summary>
/// Краткое описание GeoTargetDb
/// </summary>

public class GeoTargetDb
{
  public static string GetRegion(long longIp)
  {
    // создание объекта SqlCommand с подключением базы данных маскирования
    SqlCommand command = createCommand("GeoTargetDatabase");

    // указание имени хранимой процедуры для выполнения
    command.CommandText = "GeoTargetGetRegion";

    // @IP
    SqlParameter p = new SqlParameter("@IP", longIp);
    command.Parameters.Add(p);

    // выполнение хранимой процедуры
    command.Connection.Open();
    string countryCode;

    try { countryCode = command.ExecuteScalar().ToString(); }
    catch { countryCode = ""; }
    finally { command.Connection.Close(); }

    // возврат кода страны
    return countryCode;
  }

  // Создание и подготовка нового объекта SqlCommand для нового подключения
  private static SqlCommand createCommand(string connectionName)
  {
    // получение строки подключения к базе данных
    string connectionString =
      ConfigurationManager.ConnectionStrings[connectionName].ConnectionString;

    // получение объекта подключения к конкретной базе данных
    SqlConnection conn = new SqlConnection(connectionString);

    // создание объекта команды для конкретной базы данных
    SqlCommand comm = conn.CreateCommand();

    // указание типа команды хранимой процедуре
    comm.CommandType = CommandType.StoredProcedure;

    // возврат инициализированного объекта команды
    return comm;
  }
}