﻿<%@ Page Language="C#" EnableViewState="false" %>
<%@ Import Namespace="System.Data" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
  // атрибуты продуктов хранятся в виде приватных полей
  private string categoryId;
  private string categoryName;
  private int page;
  private int howManyPages;

  // заполнение формы данными
  protected void Page_Load(object sender, EventArgs e)
  {
    // получение ID категории
    categoryId = Request.QueryString["CategoryID"];

    // получение названия категории
    DataRow categoryRow = CatalogDb.GetCategory(categoryId);
    categoryName = categoryRow["Name"].ToString();

    // которая страница?
    string pageString = Request.QueryString["Page"];
    page = (pageString == null) ? 1 : int.Parse(pageString);

    // вывод продуктов категории и получение количества страниц
    productsRepeater.DataSource = CatalogDb.GetProductsInCategory(categoryId, page, out howManyPages);
    productsRepeater.DataBind();

    // если запрошенный номер страницы больше их общего количества – код 404
    if (page > howManyPages)
    {
      UrlTools.NotFound();
    }

    // создание ArrayList с номерами страниц
    ArrayList pageNumbers = new ArrayList();
    for (int i = 1; i <= howManyPages; i++) pageNumbers.Add(i);

    // связывание pagerRepeater с массивом номеров страниц
    pagerRepeater.DataSource = pageNumbers;
    pagerRepeater.DataBind();
  }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
  <title><%= categoryName %> - Лавка пряников Шрека</title>
</head>
<body>
  <form id="form1" runat="server">
    <h1>
      <%= categoryName %> - 
      <a href="<%= UrlTools.SiteDomain %>">Лавка пряников Шрека</a>
    </h1>
    <p>
      У нас замечательная коллекция пряников вида<b><%= categoryName %></b>!
    </p>

    <!-- Вывод списка продуктов с помощью повторителя -->
    <asp:Repeater ID="productsRepeater" runat="server">
      <HeaderTemplate>
        <ul>
      </HeaderTemplate>
      <ItemTemplate>
        <li>
          <a href="<%# LinkFactory.MakeCategoryProductUrl(categoryName, categoryId, Eval("Name").ToString(), Eval("ID").ToString()) %>">
            <%# Eval("Name") %>
          </a>
        </li>
      </ItemTemplate>
      <FooterTemplate>
        </ul>
      </FooterTemplate>
    </asp:Repeater>

    <!-- Вывод ссылок на страницы с помощью повторителя -->
    <asp:Repeater ID="pagerRepeater" runat="server">
      <HeaderTemplate>
        <asp:HyperLink ID="h2" runat="server" Text="<< назад" 
          NavigateUrl='<%# LinkFactory.MakeCategoryUrl(categoryName, categoryId, page - 1) %>'
          Enabled='<%# page > 1 %>' /> |
      </HeaderTemplate>
      <ItemTemplate>
        <asp:HyperLink ID="h3" runat="server" Text='<%# Container.DataItem %>' 
          NavigateUrl='<%# LinkFactory.MakeCategoryUrl(categoryName, categoryId, (int)Container.DataItem) %>'
        Enabled='<%# page != (int)Container.DataItem %>' /> |
      </ItemTemplate>
      <FooterTemplate>
        <asp:HyperLink ID="h2" runat="server" Text="вперед >>" 
          NavigateUrl='<%# LinkFactory.MakeCategoryUrl(categoryName, categoryId, page + 1) %>'
        Enabled='<%# page < howManyPages %>' />
      </FooterTemplate>
    </asp:Repeater>
  </form>
</body>
</html>