﻿<%@ Application Language="C#" %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Net.Mail" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">
  void Application_BeginRequest(object sender, EventArgs e)
  {
    // проверка, используется ли стандартный URL; если нет – перенаправление 301
    UrlTools.CheckUrl();
  }

  void Application_Start(object sender, EventArgs e) 
  {
    // Code that runs on application startup
  }
    
  void Application_End(object sender, EventArgs e) 
  {
    //  Code that runs on application shutdown
  }

  // отправка почтового сообщения при возбуждении необрабатываемого исключения
  void Application_Error(Object sender, EventArgs e)
  {
    // получение информации об исключении
    Exception ex = Server.GetLastError();
    if (ex.InnerException != null) ex = ex.InnerException;

    // получение текущей даты и времени
    string dateTime = DateTime.Now.ToLongDateString() + ", в "
      + DateTime.Now.ToShortTimeString();

    // составление сообщения об ошибке
    string errorMessage = "Сгенерировано исключение " + dateTime;
    System.Web.HttpContext context = System.Web.HttpContext.Current;
    errorMessage += "\n\n Адрес страницы: " + context.Request.RawUrl;
    errorMessage += "\n\n Сообщение: " + ex.Message;
    errorMessage += "\n\n Источник: " + ex.Source;
    errorMessage += "\n\n Метод: " + ex.TargetSite;
    errorMessage += "\n\n Трасса стека: \n\n" + ex.StackTrace;

    // отправка информации об ошибке
    string mailServer = ConfigurationManager.AppSettings["EmailServer"];
    string from = ConfigurationManager.AppSettings["ErrorEmailFrom"];
    string to = ConfigurationManager.AppSettings["ErrorEmailTo"];
    string smtpUser = ConfigurationManager.AppSettings["SmtpHostUserName"];
    string smtpPassword = ConfigurationManager.AppSettings["SmtpHostPassword"];

    string subject = "Отчет об ошибке на example.com";
    try
    {
      SmtpClient mailClient = new SmtpClient(mailServer);
      MailMessage mailMessage = new MailMessage(from, to, subject, errorMessage);
      mailClient.Credentials = new NetworkCredential(smtpUser, smtpPassword);
      mailClient.Send(mailMessage);
    }
    catch (Exception myex) { }
  }

  void Session_Start(object sender, EventArgs e) 
  {
    // Code that runs when a new session is started
  }

  void Session_End(object sender, EventArgs e) 
  {
    // Code that runs when a session ends. 
    // Note: The Session_End event is raised only when the sessionstate mode
    // is set to InProc in the Web.config file. If session mode is set to StateServer 
    // or SQLServer, the event is not raised.
  }
</script>
