﻿<%@ Page Language="C#" EnableViewState="False" %>
<%@ Import Namespace="System.Data" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
  // атрибуты продуктов хранятся в виде приватных полей
  private string productId, productName, productDescription;
  private decimal productPrice;
  private string brandId, brandName;  
  private string primaryCategoryId, primaryCategoryName;

  // заполнение формы информацией о продукте
  protected void Page_Load(object sender, EventArgs e)
  {     
    // получение ID продукта
    productId = Request.QueryString["ProductID"];

    // получение информации о продукте и посылка кода 404, если такого нет
    DataRow productRow = CatalogDb.GetProduct(productId);
    if (productRow == null)
    {
      UrlTools.NotFound();
      return;
    }
    else
    {
      // чтение информации о продукте из DataRow
      productName = productRow["Name"].ToString();      
      productPrice = decimal.Parse(productRow["Price"].ToString());
      productDescription = productRow["Description"].ToString();
      primaryCategoryId = productRow["PrimaryCategoryID"].ToString();
      brandId = productRow["BrandID"].ToString();

      // полчение названия брэнда
      brandName = CatalogDb.GetBrand(brandId)["Name"].ToString();

      // получение названия основной категории
      primaryCategoryName = 
        CatalogDb.GetCategory(primaryCategoryId)["Name"].ToString();

      // нужно для поддержки событий PostBack на странице
      Context.RewritePath("/?");
    }
  }

  protected void addToCartButton_Click(object sender, EventArgs e)
  {
    cartLabel.Text = "Продукт добавлен в вашу корзину!";
  }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
  <title><%= productName %> - Лавка пряников Шрека</title>
</head>
<body>
  <form id="form1" runat="server">
    <!-- Вывод заголовка со ссылкой на домашнюю страницу -->
    <h1>
      <%= productName %> - 
      <a href="<%= UrlTools.SiteDomain %>">Лавка пряников Шрека</a>
    </h1>

    <!-- Вывод описания продукта -->    
    <p><%= productDescription %></p>

    <!-- Вывод названия и логотипа брэнда -->    
    <p>Этот пряник принес вам <b><%= brandName %></b>.</p>
    <p><img src="<%= LinkFactory.MakeMediaUrl(brandName, "jpg", brandId) %>"/></p>

    <!-- Вывод цены продукта -->
    <p>Цена: 
      <%= GeoTarget.IsRegionCode("UA") ? 
            String.Format("{0:c} грн", productPrice * (decimal)0.20) : 
            String.Format("{0:c} руб", productPrice)  %>
    </p>

    <!-- Добавление в кнопку и метку корзины -->
    <p>
      <asp:Button ID="addToCartButton" runat="server" Text="Добавить в корзину" OnClick="addToCartButton_Click" />
      <asp:Label ID="cartLabel" runat="server" />
    </p>

    <!-- Ссылка на основную категорию продукта -->
    Посмотрите другие продукты в нашей категории 
    <a href="<%= LinkFactory.MakeCategoryUrl(primaryCategoryName, primaryCategoryId) %>">
      <%= primaryCategoryName %></a>
    .
  </form>
</body>
</html>