﻿<%@ WebHandler Language="C#" Class="Robots" %>
using System.Web;
using System.Data;

public class Robots : IHttpHandler
{
  public void ProcessRequest(HttpContext context)
  {
    // получение текущего объекта HttpResponse
    HttpResponse response = context.Response;

    // указание нужного типа контента и посылка строки Disallow
    response.ContentType = "text/plain";
    response.Write("User-agent: * \n");

    // объявление нужных переменных
    string productId, productName, categoryId, categoryName, url;

    // выборка категорий продуктов, которые нужно исключить
    DataTable toExcludeTable = CatalogDb.GetSecondaryProductCategories();

    // просмотр списка продуктов и категорий и исключение их ссылок
    foreach (DataRow row in toExcludeTable.Rows)
    {
      // выборка информации из строки данных
      productId = row["ProductID"].ToString();
      productName = row["ProductName"].ToString();
      categoryId = row["SecondaryCategoryID"].ToString();
      categoryName = row["SecondaryCategoryName"].ToString();

      // получение URL с помощью генератора ссылок
      url = LinkFactory.MakeCategoryProductUrl(categoryName, categoryId,
                                               productName, productId);

      // удаление доменного имени из URL
      url = url.Replace(UrlTools.SiteDomain, "");

      // вывод URL для его исключения
      response.Write(string.Format("Disallow: {0} \n", url));
    }

    // добавление статических данных исключения из robots_static.txt
    context.Response.WriteFile("~/robots_static.txt");
  }

  public bool IsReusable
  {
    get { return false; }
  }
}